/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;




/**
 * tmarkplugin.config.Property for a single boolean
 * @author Tomas Schackert
 *
 */
public class BooleanProperty extends Property{
	String key;
	boolean value=false;
	boolean defaultvalue;
	boolean loaded=false;
	
	
	public BooleanProperty(PropertySource props,String key,boolean defaultvalue){
		super(props);
		this.key=key;
		this.defaultvalue=defaultvalue;
	}
	public BooleanProperty(PropertySource props,BooleanProperty src){
		super(props);
		this.key=src.key;
		this.defaultvalue=src.defaultvalue;
		this.value=src.get();
		loaded=true;
	}
	public BooleanProperty(boolean value, boolean defaultvalue){
		super(null);
		this.key=null;
		this.defaultvalue=defaultvalue;
		this.value=value;
		loaded=true;
	}
	
	private void load(){
		value=this.getBoolProperty(key,defaultvalue);
		loaded=true;
	}
	public boolean get(){
		if (!loaded) load();
		return value;
	}
	public void set(boolean v){
		this.setBoolProperty(key,this.value=v);
		fireChanged();
	}
	public void reset() {
		set(defaultvalue);
	}
}
